package b4a.CustomKeyboardSample2;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.CustomKeyboardSample2", "b4a.CustomKeyboardSample2.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.CustomKeyboardSample2", "b4a.CustomKeyboardSample2.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.CustomKeyboardSample2.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static String _v0 = "";
public static int _type_text_flag_no_suggestions = 0;
public anywheresoftware.b4a.object.XmlLayoutBuilder _v6 = null;
public bm.watscho.keyboard.CustomKeyboard _v7 = null;
public anywheresoftware.b4a.objects.PanelWrapper _editpanel = null;
public anywheresoftware.b4a.objects.EditTextWrapper _etcust1 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _etcust2 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _v5 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnunregreg = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btngetevents = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnchangekeyboard = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static class _typarg{
public boolean IsInitialized;
public Object Arg1;
public Object Arg2;
public Object Arg3;
public Object Arg4;
public Object Arg5;
public void Initialize() {
IsInitialized = true;
Arg1 = new Object();
Arg2 = new Object();
Arg3 = new Object();
Arg4 = new Object();
Arg5 = new Object();
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}
public static String  _activity_create(boolean _firsttime) throws Exception{
int _i = 0;
anywheresoftware.b4a.objects.ConcreteViewWrapper _v = null;
 //BA.debugLineNum = 41;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 54;BA.debugLine="Activity.LoadLayout(\"ckbtest\")";
mostCurrent._activity.LoadLayout("ckbtest",mostCurrent.activityBA);
 //BA.debugLineNum = 55;BA.debugLine="etCust3.Initialize(\"\")";
mostCurrent._v5.Initialize(mostCurrent.activityBA,"");
 //BA.debugLineNum = 56;BA.debugLine="XLB.LoadXmlLayout(EditPanel, \"etcust3\")'load the";
mostCurrent._v6.LoadXmlLayout(mostCurrent.activityBA,(android.view.ViewGroup)(mostCurrent._editpanel.getObject()),"etcust3");
 //BA.debugLineNum = 62;BA.debugLine="Dim i As Int";
_i = 0;
 //BA.debugLineNum = 63;BA.debugLine="For Each v As View In EditPanel.GetAllViewsRecurs";
_v = new anywheresoftware.b4a.objects.ConcreteViewWrapper();
final anywheresoftware.b4a.BA.IterableList group21 = mostCurrent._editpanel.GetAllViewsRecursive();
final int groupLen21 = group21.getSize();
for (int index21 = 0;index21 < groupLen21 ;index21++){
_v.setObject((android.view.View)(group21.Get(index21)));
 //BA.debugLineNum = 64;BA.debugLine="If v.Tag = \"et3\" Then";
if ((_v.getTag()).equals((Object)("et3"))) { 
 //BA.debugLineNum = 65;BA.debugLine="etCust3 = v";
mostCurrent._v5.setObject((android.widget.EditText)(_v.getObject()));
 //BA.debugLineNum = 66;BA.debugLine="EditPanel.RemoveViewAt(i)";
mostCurrent._editpanel.RemoveViewAt(_i);
 };
 //BA.debugLineNum = 68;BA.debugLine="i = i + 1";
_i = (int) (_i+1);
 }
;
 //BA.debugLineNum = 70;BA.debugLine="EditPanel.AddView(etCust3, etCust1.Left, etCust1.";
mostCurrent._editpanel.AddView((android.view.View)(mostCurrent._v5.getObject()),mostCurrent._etcust1.getLeft(),(int) (mostCurrent._etcust1.getTop()+mostCurrent._etcust1.getHeight()+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (10))),(int) (mostCurrent._editpanel.getWidth()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (10))),(int) (mostCurrent._editpanel.getHeight()-mostCurrent._etcust1.getHeight()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (10))));
 //BA.debugLineNum = 73;BA.debugLine="Try";
try { //BA.debugLineNum = 74;BA.debugLine="CustKeyBoard.Initialize(\"CKB\", \"keyboardview\")'i";
mostCurrent._v7.Initialize(mostCurrent.activityBA,"CKB","keyboardview");
 //BA.debugLineNum = 75;BA.debugLine="CustKeyBoard.RegisterEditText(etCust1,\"etCust\",\"";
mostCurrent._v7.RegisterEditText((android.widget.EditText)(mostCurrent._etcust1.getObject()),"etCust","ipkeyboardpn",anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 76;BA.debugLine="CustKeyBoard.RegisterEditText(etCust2,\"etCust\",\"";
mostCurrent._v7.RegisterEditText((android.widget.EditText)(mostCurrent._etcust2.getObject()),"etCust","nrkeyboardpn",anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 77;BA.debugLine="CustKeyBoard.RegisterEditText(etCust3,\"etCust\",\"";
mostCurrent._v7.RegisterEditText((android.widget.EditText)(mostCurrent._v5.getObject()),"etCust","standard",anywheresoftware.b4a.keywords.Common.True);
 } 
       catch (Exception e35) {
			processBA.setLastException(e35); //BA.debugLineNum = 79;BA.debugLine="Msgbox(\"There was an error in the 'Initialize/Re";
anywheresoftware.b4a.keywords.Common.Msgbox("There was an error in the 'Initialize/Register' method of the CustomKeyboard-library. Most probably a missing xml-file(misspelling?)","CUSTOMKEYBOARD-ERROR",mostCurrent.activityBA);
 //BA.debugLineNum = 80;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 };
 //BA.debugLineNum = 83;BA.debugLine="etCust1.InputType = Bit.OR(etCust1.InputType,TYPE";
mostCurrent._etcust1.setInputType(anywheresoftware.b4a.keywords.Common.Bit.Or(mostCurrent._etcust1.getInputType(),_type_text_flag_no_suggestions));
 //BA.debugLineNum = 84;BA.debugLine="etCust2.InputType = Bit.OR(etCust2.InputType,TYPE";
mostCurrent._etcust2.setInputType(anywheresoftware.b4a.keywords.Common.Bit.Or(mostCurrent._etcust2.getInputType(),_type_text_flag_no_suggestions));
 //BA.debugLineNum = 85;BA.debugLine="etCust1.Text = \"This EditBox accepts numbers & do";
mostCurrent._etcust1.setText((Object)("This EditBox accepts numbers & dot only (ip-addresses)"));
 //BA.debugLineNum = 86;BA.debugLine="etCust2.Text = \"This EditBox accepts decimal numb";
mostCurrent._etcust2.setText((Object)("This EditBox accepts decimal numbers only"));
 //BA.debugLineNum = 87;BA.debugLine="etCust3.Text = \"This EditBox accepts standard ASC";
mostCurrent._v5.setText((Object)("This EditBox accepts standard ASCII This EditBox accepts standard ASCII This EditBox accepts standard ASCII This EditBox accepts standard ASCII "));
 //BA.debugLineNum = 88;BA.debugLine="End Sub";
return "";
}
public static boolean  _activity_keypress(int _keycode) throws Exception{
 //BA.debugLineNum = 101;BA.debugLine="Sub Activity_KeyPress (KeyCode As Int) As Boolean";
 //BA.debugLineNum = 102;BA.debugLine="If KeyCode = KeyCodes.KEYCODE_BACK Then";
if (_keycode==anywheresoftware.b4a.keywords.Common.KeyCodes.KEYCODE_BACK) { 
 //BA.debugLineNum = 103;BA.debugLine="If CustKeyBoard.IsSoftKeyboardVisible Then";
if (mostCurrent._v7.IsSoftKeyboardVisible()) { 
 //BA.debugLineNum = 104;BA.debugLine="If CustKeyBoard.HandleBack Then Return True";
if (mostCurrent._v7.HandleBack()) { 
if (true) return anywheresoftware.b4a.keywords.Common.True;};
 //BA.debugLineNum = 105;BA.debugLine="CustKeyBoard.HideKeyboard";
mostCurrent._v7.HideKeyboard();
 //BA.debugLineNum = 106;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
 };
 };
 //BA.debugLineNum = 109;BA.debugLine="Return False";
if (true) return anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 110;BA.debugLine="End Sub";
return false;
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 97;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 99;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 90;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 91;BA.debugLine="If Not(CustKeyBoard.IsOScompatible) Then";
if (anywheresoftware.b4a.keywords.Common.Not(mostCurrent._v7.IsOScompatible())) { 
 //BA.debugLineNum = 92;BA.debugLine="Msgbox(\"!!! This app needs at least APILEVEL 15,";
anywheresoftware.b4a.keywords.Common.Msgbox("!!! This app needs at least APILEVEL 15, the app ends now !!! ","CKBTEST-FAIL",mostCurrent.activityBA);
 //BA.debugLineNum = 93;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 };
 //BA.debugLineNum = 95;BA.debugLine="End Sub";
return "";
}
public static String  _btnchangekeyboard_click() throws Exception{
String _newkeyboard = "";
 //BA.debugLineNum = 131;BA.debugLine="Sub btnChangeKeyboard_Click";
 //BA.debugLineNum = 132;BA.debugLine="Dim NewKeyboard As String";
_newkeyboard = "";
 //BA.debugLineNum = 133;BA.debugLine="Select Case CustKeyBoard.GetCurLayoutFile";
switch (BA.switchObjectToInt(mostCurrent._v7.GetCurLayoutFile(),"ipkeyboardpn","standard")) {
case 0:
 //BA.debugLineNum = 135;BA.debugLine="NewKeyboard = \"standard\"";
_newkeyboard = "standard";
 //BA.debugLineNum = 136;BA.debugLine="etCust3.Text = \"This EditBox accepts standard A";
mostCurrent._v5.setText((Object)("This EditBox accepts standard ASCII"));
 break;
case 1:
 //BA.debugLineNum = 138;BA.debugLine="NewKeyboard = \"ipkeyboardpn\"";
_newkeyboard = "ipkeyboardpn";
 //BA.debugLineNum = 139;BA.debugLine="etCust3.Text = \"This EditBox accepts numbers &";
mostCurrent._v5.setText((Object)("This EditBox accepts numbers & dot only (ip-addresses)"));
 break;
}
;
 //BA.debugLineNum = 141;BA.debugLine="Try";
try { //BA.debugLineNum = 142;BA.debugLine="CustKeyBoard.ChangeKeyboardLayout(etCust3,NewKey";
mostCurrent._v7.ChangeKeyboardLayout((android.widget.EditText)(mostCurrent._v5.getObject()),_newkeyboard);
 } 
       catch (Exception e95) {
			processBA.setLastException(e95); //BA.debugLineNum = 144;BA.debugLine="Msgbox(\"There was an error in the 'ChangeKeyboar";
anywheresoftware.b4a.keywords.Common.Msgbox("There was an error in the 'ChangeKeyboardLayout' method of the CustomKeyboard-library. Most probably a missing xml-file(misspelling?)","CUSTOMKEYBOARD-ERROR",mostCurrent.activityBA);
 //BA.debugLineNum = 145;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 };
 //BA.debugLineNum = 147;BA.debugLine="End Sub";
return "";
}
public static String  _btngetevents_click() throws Exception{
 //BA.debugLineNum = 127;BA.debugLine="Sub btnGetEvents_Click";
 //BA.debugLineNum = 128;BA.debugLine="Msgbox(eventtest,\"FIRED EVENTS\")";
anywheresoftware.b4a.keywords.Common.Msgbox(_v0,"FIRED EVENTS",mostCurrent.activityBA);
 //BA.debugLineNum = 129;BA.debugLine="eventtest=\"\"";
_v0 = "";
 //BA.debugLineNum = 130;BA.debugLine="End Sub";
return "";
}
public static String  _btnunregreg_click() throws Exception{
 //BA.debugLineNum = 111;BA.debugLine="Sub btnUnregReg_Click";
 //BA.debugLineNum = 112;BA.debugLine="If CustKeyBoard.GetRegisteredStatus(etCust1) = \"n";
if ((mostCurrent._v7.GetRegisteredStatus((android.widget.EditText)(mostCurrent._etcust1.getObject()))).equals("neverregistered")) { 
 //BA.debugLineNum = 113;BA.debugLine="Try";
try { //BA.debugLineNum = 114;BA.debugLine="CustKeyBoard.RegisterEditText(etCust1,\"etCust\",";
mostCurrent._v7.RegisterEditText((android.widget.EditText)(mostCurrent._etcust1.getObject()),"etCust","ipkeyboardpn",anywheresoftware.b4a.keywords.Common.True);
 } 
       catch (Exception e67) {
			processBA.setLastException(e67); //BA.debugLineNum = 116;BA.debugLine="Msgbox(\"There was an error in the 'Register' me";
anywheresoftware.b4a.keywords.Common.Msgbox("There was an error in the 'Register' method of the CustomKeyboard-library. Most probably a missing xml-file(misspelling?)","CUSTOMKEYBOARD-ERROR",mostCurrent.activityBA);
 //BA.debugLineNum = 117;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 };
 //BA.debugLineNum = 119;BA.debugLine="btnUnregReg.Text = \"UNREGISTER ET1\"";
mostCurrent._btnunregreg.setText((Object)("UNREGISTER ET1"));
 //BA.debugLineNum = 120;BA.debugLine="etCust1.Text = \"This EditBox accepts numbers & d";
mostCurrent._etcust1.setText((Object)("This EditBox accepts numbers & dot only (ip-addresses)"));
 }else {
 //BA.debugLineNum = 122;BA.debugLine="CustKeyBoard.UnregisterEditText(etCust1)";
mostCurrent._v7.UnregisterEditText((android.widget.EditText)(mostCurrent._etcust1.getObject()));
 //BA.debugLineNum = 123;BA.debugLine="btnUnregReg.Text = \"REGISTER ET1\"";
mostCurrent._btnunregreg.setText((Object)("REGISTER ET1"));
 //BA.debugLineNum = 124;BA.debugLine="etCust1.Text = \"This EditBox accepts standard AS";
mostCurrent._etcust1.setText((Object)("This EditBox accepts standard ASCII"));
 };
 //BA.debugLineNum = 126;BA.debugLine="End Sub";
return "";
}
public static String  _ckb_heightchanged(int _newheight,int _oldheight) throws Exception{
b4a.CustomKeyboardSample2.main._typarg _myargs = null;
 //BA.debugLineNum = 277;BA.debugLine="Sub CKB_HeightChanged(NewHeight As Int, OldHeight";
 //BA.debugLineNum = 278;BA.debugLine="Dim MyArgs As typArg";
_myargs = new b4a.CustomKeyboardSample2.main._typarg();
 //BA.debugLineNum = 280;BA.debugLine="CallSubDelayed3(Me,\"SetEditTextHeight\",NewHeight,";
anywheresoftware.b4a.keywords.Common.CallSubDelayed3(mostCurrent.activityBA,main.getObject(),"SetEditTextHeight",(Object)(_newheight),(Object)(_oldheight));
 //BA.debugLineNum = 282;BA.debugLine="End Sub";
return "";
}
public static boolean  _ckb_keypressed(Object _viewtag,int _primarykeycode,int[] _addkeycodes) throws Exception{
int _codeshift = 0;
int _codemodechange = 0;
int _codecancel = 0;
int _codedone = 0;
int _codedelete = 0;
int _codealt = 0;
int _codeprev = 0;
int _codeallleft = 0;
int _codeleft = 0;
int _coderight = 0;
int _codeallright = 0;
int _codenext = 0;
int _codeclear = 0;
int _codeup = 0;
int _codedown = 0;
int _codereturn = 0;
String _tag = "";
 //BA.debugLineNum = 290;BA.debugLine="Sub CKB_KeyPressed (ViewTag As Object, PrimaryKeyC";
 //BA.debugLineNum = 331;BA.debugLine="Dim CodeShift As Int = -1  		'Keyboard.KEYCODE_SH";
_codeshift = (int) (-1);
 //BA.debugLineNum = 332;BA.debugLine="Dim CodeModeChange As Int = -2  'Keyboard.KEYCODE";
_codemodechange = (int) (-2);
 //BA.debugLineNum = 333;BA.debugLine="Dim CodeCancel As Int = -3  	'Keyboard.KEYCODE_CA";
_codecancel = (int) (-3);
 //BA.debugLineNum = 334;BA.debugLine="Dim CodeDone As Int = -4  		'Keyboard.KEYCODE_DON";
_codedone = (int) (-4);
 //BA.debugLineNum = 335;BA.debugLine="Dim CodeDelete As Int = -5  	'Keyboard.KEYCODE_DE";
_codedelete = (int) (-5);
 //BA.debugLineNum = 336;BA.debugLine="Dim CodeAlt As Int = -6  		'Keyboard.KEYCODE_ALT";
_codealt = (int) (-6);
 //BA.debugLineNum = 339;BA.debugLine="Dim CodePrev As Int = 60000";
_codeprev = (int) (60000);
 //BA.debugLineNum = 340;BA.debugLine="Dim CodeAllLeft As Int = 60001";
_codeallleft = (int) (60001);
 //BA.debugLineNum = 341;BA.debugLine="Dim CodeLeft As Int = 60002";
_codeleft = (int) (60002);
 //BA.debugLineNum = 342;BA.debugLine="Dim CodeRight As Int = 60003";
_coderight = (int) (60003);
 //BA.debugLineNum = 343;BA.debugLine="Dim CodeAllRight As Int = 60004";
_codeallright = (int) (60004);
 //BA.debugLineNum = 344;BA.debugLine="Dim CodeNext As Int = 60005";
_codenext = (int) (60005);
 //BA.debugLineNum = 345;BA.debugLine="Dim CodeClear As Int = 60006";
_codeclear = (int) (60006);
 //BA.debugLineNum = 346;BA.debugLine="Dim CodeUp As Int = 60007";
_codeup = (int) (60007);
 //BA.debugLineNum = 347;BA.debugLine="Dim CodeDown As Int = 60008";
_codedown = (int) (60008);
 //BA.debugLineNum = 348;BA.debugLine="Dim CodeReturn As Int = 60009";
_codereturn = (int) (60009);
 //BA.debugLineNum = 350;BA.debugLine="Dim Tag As String = ViewTag";
_tag = BA.ObjectToString(_viewtag);
 //BA.debugLineNum = 351;BA.debugLine="If (PrimaryKeyCode >= 0xE000) OR (PrimaryKeyCode";
if ((_primarykeycode>=0xe000) || (_primarykeycode<=0)) { 
 //BA.debugLineNum = 352;BA.debugLine="Select Case Tag";
switch (BA.switchObjectToInt(_tag,"et1","et2","et3")) {
case 0:
 //BA.debugLineNum = 355;BA.debugLine="eventtest = eventtest & \"et1_KP, \"";
_v0 = _v0+"et1_KP, ";
 //BA.debugLineNum = 356;BA.debugLine="Return False";
if (true) return anywheresoftware.b4a.keywords.Common.False;
 break;
case 1:
 //BA.debugLineNum = 359;BA.debugLine="eventtest = eventtest & \"et2_KP, \"";
_v0 = _v0+"et2_KP, ";
 //BA.debugLineNum = 360;BA.debugLine="Return False";
if (true) return anywheresoftware.b4a.keywords.Common.False;
 break;
case 2:
 //BA.debugLineNum = 363;BA.debugLine="eventtest = eventtest & \"et3_KP, \"";
_v0 = _v0+"et3_KP, ";
 //BA.debugLineNum = 364;BA.debugLine="Return False";
if (true) return anywheresoftware.b4a.keywords.Common.False;
 break;
}
;
 }else {
 //BA.debugLineNum = 367;BA.debugLine="Select Case Tag";
switch (BA.switchObjectToInt(_tag,"et1","et2","et3")) {
case 0:
 //BA.debugLineNum = 370;BA.debugLine="eventtest = eventtest & \"et1_KP, \"";
_v0 = _v0+"et1_KP, ";
 //BA.debugLineNum = 371;BA.debugLine="Return False";
if (true) return anywheresoftware.b4a.keywords.Common.False;
 break;
case 1:
 //BA.debugLineNum = 374;BA.debugLine="eventtest = eventtest & \"et2_KP, \"";
_v0 = _v0+"et2_KP, ";
 //BA.debugLineNum = 375;BA.debugLine="Return False";
if (true) return anywheresoftware.b4a.keywords.Common.False;
 break;
case 2:
 //BA.debugLineNum = 378;BA.debugLine="eventtest = eventtest & \"et3_KP, \"";
_v0 = _v0+"et3_KP, ";
 //BA.debugLineNum = 379;BA.debugLine="Return False";
if (true) return anywheresoftware.b4a.keywords.Common.False;
 break;
}
;
 };
 //BA.debugLineNum = 382;BA.debugLine="End Sub";
return false;
}
public static String  _ckb_onkeydown(Object _viewtag,int _primarykeycode) throws Exception{
String _tag = "";
 //BA.debugLineNum = 383;BA.debugLine="Sub CKB_onKeyDown(ViewTag As Object, PrimaryKeyCod";
 //BA.debugLineNum = 384;BA.debugLine="Dim Tag As String = ViewTag";
_tag = BA.ObjectToString(_viewtag);
 //BA.debugLineNum = 386;BA.debugLine="Select Case Tag";
switch (BA.switchObjectToInt(_tag,"et1","et2","et3")) {
case 0:
 //BA.debugLineNum = 388;BA.debugLine="eventtest = eventtest & \"et1_KD, \"";
_v0 = _v0+"et1_KD, ";
 break;
case 1:
 //BA.debugLineNum = 390;BA.debugLine="eventtest = eventtest & \"et2_KD, \"";
_v0 = _v0+"et2_KD, ";
 break;
case 2:
 //BA.debugLineNum = 392;BA.debugLine="eventtest = eventtest & \"et3_KD, \"";
_v0 = _v0+"et3_KD, ";
 break;
}
;
 //BA.debugLineNum = 394;BA.debugLine="End Sub";
return "";
}
public static String  _ckb_onkeyup(Object _viewtag,int _primarykeycode) throws Exception{
String _tag = "";
 //BA.debugLineNum = 395;BA.debugLine="Sub CKB_onKeyUp(ViewTag As Object, PrimaryKeyCode";
 //BA.debugLineNum = 396;BA.debugLine="Dim Tag As String = ViewTag";
_tag = BA.ObjectToString(_viewtag);
 //BA.debugLineNum = 398;BA.debugLine="Select Case Tag";
switch (BA.switchObjectToInt(_tag,"et1","et2","et3")) {
case 0:
 //BA.debugLineNum = 400;BA.debugLine="eventtest = eventtest & \"et1_KU, \"";
_v0 = _v0+"et1_KU, ";
 break;
case 1:
 //BA.debugLineNum = 402;BA.debugLine="eventtest = eventtest & \"et2_KU, \"";
_v0 = _v0+"et2_KU, ";
 break;
case 2:
 //BA.debugLineNum = 404;BA.debugLine="eventtest = eventtest & \"et3_KU, \"";
_v0 = _v0+"et3_KU, ";
 break;
}
;
 //BA.debugLineNum = 406;BA.debugLine="End Sub";
return "";
}
public static String  _etcust_click() throws Exception{
anywheresoftware.b4a.objects.EditTextWrapper _e = null;
 //BA.debugLineNum = 237;BA.debugLine="Sub etCust_Click()";
 //BA.debugLineNum = 238;BA.debugLine="Dim e As EditText = Sender";
_e = new anywheresoftware.b4a.objects.EditTextWrapper();
_e.setObject((android.widget.EditText)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 240;BA.debugLine="CallSubDelayed2(Me,\"SetClick\",e.Tag)";
anywheresoftware.b4a.keywords.Common.CallSubDelayed2(mostCurrent.activityBA,main.getObject(),"SetClick",_e.getTag());
 //BA.debugLineNum = 242;BA.debugLine="End Sub";
return "";
}
public static String  _etcust_focuschanged(boolean _hasfocus) throws Exception{
anywheresoftware.b4a.objects.EditTextWrapper _e = null;
b4a.CustomKeyboardSample2.main._typarg _myargs = null;
 //BA.debugLineNum = 199;BA.debugLine="Sub etCust_FocusChanged (HasFocus As Boolean)";
 //BA.debugLineNum = 200;BA.debugLine="Dim e As EditText = Sender";
_e = new anywheresoftware.b4a.objects.EditTextWrapper();
_e.setObject((android.widget.EditText)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 201;BA.debugLine="Dim MyArgs As typArg";
_myargs = new b4a.CustomKeyboardSample2.main._typarg();
 //BA.debugLineNum = 203;BA.debugLine="MyArgs.Initialize";
_myargs.Initialize();
 //BA.debugLineNum = 204;BA.debugLine="MyArgs.Arg1 = e.Tag";
_myargs.Arg1 = _e.getTag();
 //BA.debugLineNum = 205;BA.debugLine="MyArgs.Arg2 = HasFocus";
_myargs.Arg2 = (Object)(_hasfocus);
 //BA.debugLineNum = 206;BA.debugLine="CallSubDelayed2(Me,\"SetFocusChanged\",MyArgs)";
anywheresoftware.b4a.keywords.Common.CallSubDelayed2(mostCurrent.activityBA,main.getObject(),"SetFocusChanged",(Object)(_myargs));
 //BA.debugLineNum = 208;BA.debugLine="End Sub";
return "";
}
public static boolean  _etcust_handleaction() throws Exception{
anywheresoftware.b4a.objects.EditTextWrapper _e = null;
 //BA.debugLineNum = 265;BA.debugLine="Sub etCust_HandleAction() As Boolean";
 //BA.debugLineNum = 266;BA.debugLine="Dim e As EditText = Sender";
_e = new anywheresoftware.b4a.objects.EditTextWrapper();
_e.setObject((android.widget.EditText)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 268;BA.debugLine="Select Case e.Tag";
switch (BA.switchObjectToInt(_e.getTag(),(Object)("et1"),(Object)("et2"),(Object)("et3"))) {
case 0:
 //BA.debugLineNum = 270;BA.debugLine="eventtest = eventtest & \"et1_HA, \"";
_v0 = _v0+"et1_HA, ";
 break;
case 1:
 //BA.debugLineNum = 272;BA.debugLine="eventtest = eventtest & \"et2_HA, \"";
_v0 = _v0+"et2_HA, ";
 break;
case 2:
 //BA.debugLineNum = 274;BA.debugLine="eventtest = eventtest & \"et3_HA, \"";
_v0 = _v0+"et3_HA, ";
 break;
}
;
 //BA.debugLineNum = 276;BA.debugLine="End Sub";
return false;
}
public static String  _etcust_textchanged(String _old,String _new) throws Exception{
anywheresoftware.b4a.objects.EditTextWrapper _e = null;
 //BA.debugLineNum = 253;BA.debugLine="Sub etCust_TextChanged (Old As String, New As Stri";
 //BA.debugLineNum = 254;BA.debugLine="Dim e As EditText = Sender";
_e = new anywheresoftware.b4a.objects.EditTextWrapper();
_e.setObject((android.widget.EditText)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 256;BA.debugLine="Select Case e.Tag";
switch (BA.switchObjectToInt(_e.getTag(),(Object)("et1"),(Object)("et2"),(Object)("et3"))) {
case 0:
 //BA.debugLineNum = 258;BA.debugLine="eventtest = eventtest & \"et1_TC, \"";
_v0 = _v0+"et1_TC, ";
 break;
case 1:
 //BA.debugLineNum = 260;BA.debugLine="eventtest = eventtest & \"et2_TC, \"";
_v0 = _v0+"et2_TC, ";
 break;
case 2:
 //BA.debugLineNum = 262;BA.debugLine="eventtest = eventtest & \"et3_TC, \"";
_v0 = _v0+"et3_TC, ";
 break;
}
;
 //BA.debugLineNum = 264;BA.debugLine="End Sub";
return "";
}
public static boolean  _etcust_touch(int _action,float _x,float _y,Object _motionevent) throws Exception{
anywheresoftware.b4a.objects.EditTextWrapper _e = null;
b4a.CustomKeyboardSample2.main._typarg _myargs = null;
 //BA.debugLineNum = 148;BA.debugLine="Sub etCust_Touch (Action As Int, X As Float, Y As";
 //BA.debugLineNum = 149;BA.debugLine="Dim e As EditText = Sender";
_e = new anywheresoftware.b4a.objects.EditTextWrapper();
_e.setObject((android.widget.EditText)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 150;BA.debugLine="Dim MyArgs As typArg";
_myargs = new b4a.CustomKeyboardSample2.main._typarg();
 //BA.debugLineNum = 152;BA.debugLine="MyArgs.Initialize";
_myargs.Initialize();
 //BA.debugLineNum = 153;BA.debugLine="MyArgs.Arg1 = e.Tag";
_myargs.Arg1 = _e.getTag();
 //BA.debugLineNum = 154;BA.debugLine="MyArgs.Arg2 = Action";
_myargs.Arg2 = (Object)(_action);
 //BA.debugLineNum = 155;BA.debugLine="MyArgs.Arg3 = X";
_myargs.Arg3 = (Object)(_x);
 //BA.debugLineNum = 156;BA.debugLine="MyArgs.Arg4 = Y";
_myargs.Arg4 = (Object)(_y);
 //BA.debugLineNum = 157;BA.debugLine="MyArgs.Arg5 = MotionEvent";
_myargs.Arg5 = _motionevent;
 //BA.debugLineNum = 158;BA.debugLine="CallSubDelayed2(Me,\"SetTouch\",MyArgs)";
anywheresoftware.b4a.keywords.Common.CallSubDelayed2(mostCurrent.activityBA,main.getObject(),"SetTouch",(Object)(_myargs));
 //BA.debugLineNum = 160;BA.debugLine="End Sub";
return false;
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 26;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 30;BA.debugLine="Private XLB As XmlLayoutBuilder";
mostCurrent._v6 = new anywheresoftware.b4a.object.XmlLayoutBuilder();
 //BA.debugLineNum = 31;BA.debugLine="Private CustKeyBoard As CustomKeyboard";
mostCurrent._v7 = new bm.watscho.keyboard.CustomKeyboard();
 //BA.debugLineNum = 32;BA.debugLine="Private EditPanel As Panel";
mostCurrent._editpanel = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 33;BA.debugLine="Private etCust1 As EditText";
mostCurrent._etcust1 = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 34;BA.debugLine="Private etCust2 As EditText";
mostCurrent._etcust2 = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 35;BA.debugLine="Private etCust3 As EditText";
mostCurrent._v5 = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 36;BA.debugLine="Private btnUnregReg As Button";
mostCurrent._btnunregreg = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 37;BA.debugLine="Private btnGetEvents As Button";
mostCurrent._btngetevents = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 38;BA.debugLine="Private btnChangeKeyboard As Button";
mostCurrent._btnchangekeyboard = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 39;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 17;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 21;BA.debugLine="Dim eventtest As String";
_v0 = "";
 //BA.debugLineNum = 22;BA.debugLine="Dim TYPE_TEXT_FLAG_NO_SUGGESTIONS  As Int = 0x800";
_type_text_flag_no_suggestions = (int) (0x80000);
 //BA.debugLineNum = 23;BA.debugLine="Type typArg(Arg1 As Object, Arg2 As Object, Arg3";
;
 //BA.debugLineNum = 24;BA.debugLine="End Sub";
return "";
}
public static String  _setclick(String _viewtag) throws Exception{
 //BA.debugLineNum = 243;BA.debugLine="Sub SetClick(ViewTag As String)";
 //BA.debugLineNum = 244;BA.debugLine="Select Case ViewTag";
switch (BA.switchObjectToInt(_viewtag,"et1","et2","et3")) {
case 0:
 //BA.debugLineNum = 246;BA.debugLine="eventtest = eventtest & \"et1_CL, \"";
_v0 = _v0+"et1_CL, ";
 break;
case 1:
 //BA.debugLineNum = 248;BA.debugLine="eventtest = eventtest & \"et2_CL, \"";
_v0 = _v0+"et2_CL, ";
 break;
case 2:
 //BA.debugLineNum = 250;BA.debugLine="eventtest = eventtest & \"et3_CL, \"";
_v0 = _v0+"et3_CL, ";
 break;
}
;
 //BA.debugLineNum = 252;BA.debugLine="End Sub";
return "";
}
public static String  _setedittextheight(int _newheight,int _oldheight) throws Exception{
 //BA.debugLineNum = 283;BA.debugLine="Sub SetEditTextHeight(NewHeight As Int, OldHeight";
 //BA.debugLineNum = 284;BA.debugLine="If NewHeight < OldHeight Then";
if (_newheight<_oldheight) { 
 //BA.debugLineNum = 285;BA.debugLine="eventtest = eventtest & \"KB_HCV, \"";
_v0 = _v0+"KB_HCV, ";
 }else if(_newheight>_oldheight) { 
 //BA.debugLineNum = 287;BA.debugLine="eventtest = eventtest & \"KB_HCG, \"";
_v0 = _v0+"KB_HCG, ";
 };
 //BA.debugLineNum = 289;BA.debugLine="End Sub";
return "";
}
public static String  _setfocuschanged(Object _arguments) throws Exception{
b4a.CustomKeyboardSample2.main._typarg _args = null;
String _viewtag = "";
boolean _hasfocus = false;
 //BA.debugLineNum = 209;BA.debugLine="Sub SetFocusChanged(Arguments As Object)";
 //BA.debugLineNum = 210;BA.debugLine="Dim Args As typArg = Arguments";
_args = (b4a.CustomKeyboardSample2.main._typarg)(_arguments);
 //BA.debugLineNum = 211;BA.debugLine="Dim ViewTag As String = Args.Arg1";
_viewtag = BA.ObjectToString(_args.Arg1);
 //BA.debugLineNum = 212;BA.debugLine="Dim HasFocus As Boolean = Args.Arg2";
_hasfocus = BA.ObjectToBoolean(_args.Arg2);
 //BA.debugLineNum = 214;BA.debugLine="Select Case ViewTag";
switch (BA.switchObjectToInt(_viewtag,"et1","et2","et3")) {
case 0:
 //BA.debugLineNum = 216;BA.debugLine="If HasFocus Then";
if (_hasfocus) { 
 //BA.debugLineNum = 217;BA.debugLine="eventtest = eventtest & \"et1_FCT, \"";
_v0 = _v0+"et1_FCT, ";
 }else {
 //BA.debugLineNum = 219;BA.debugLine="eventtest = eventtest & \"et1_FCF, \"";
_v0 = _v0+"et1_FCF, ";
 };
 break;
case 1:
 //BA.debugLineNum = 222;BA.debugLine="If HasFocus Then";
if (_hasfocus) { 
 //BA.debugLineNum = 223;BA.debugLine="eventtest = eventtest & \"et2_FCT, \"";
_v0 = _v0+"et2_FCT, ";
 }else {
 //BA.debugLineNum = 225;BA.debugLine="eventtest = eventtest & \"et2_FCF, \"";
_v0 = _v0+"et2_FCF, ";
 };
 break;
case 2:
 //BA.debugLineNum = 228;BA.debugLine="If HasFocus Then";
if (_hasfocus) { 
 //BA.debugLineNum = 229;BA.debugLine="eventtest = eventtest & \"et3_FCT, \"";
_v0 = _v0+"et3_FCT, ";
 //BA.debugLineNum = 230;BA.debugLine="btnChangeKeyboard.Enabled = True";
mostCurrent._btnchangekeyboard.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 }else {
 //BA.debugLineNum = 232;BA.debugLine="eventtest = eventtest & \"et3_FCF, \"";
_v0 = _v0+"et3_FCF, ";
 //BA.debugLineNum = 233;BA.debugLine="btnChangeKeyboard.Enabled = False";
mostCurrent._btnchangekeyboard.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 };
 break;
}
;
 //BA.debugLineNum = 236;BA.debugLine="End Sub";
return "";
}
public static String  _settouch(Object _arguments) throws Exception{
b4a.CustomKeyboardSample2.main._typarg _args = null;
String _viewtag = "";
int _action = 0;
float _x = 0f;
float _y = 0f;
Object _motionevent = null;
 //BA.debugLineNum = 161;BA.debugLine="Sub SetTouch(Arguments As Object)";
 //BA.debugLineNum = 162;BA.debugLine="Dim Args As typArg = Arguments";
_args = (b4a.CustomKeyboardSample2.main._typarg)(_arguments);
 //BA.debugLineNum = 163;BA.debugLine="Dim ViewTag As String = Args.Arg1";
_viewtag = BA.ObjectToString(_args.Arg1);
 //BA.debugLineNum = 164;BA.debugLine="Dim Action As Int = Args.Arg2";
_action = (int)(BA.ObjectToNumber(_args.Arg2));
 //BA.debugLineNum = 165;BA.debugLine="Dim X As Float = Args.Arg3";
_x = (float)(BA.ObjectToNumber(_args.Arg3));
 //BA.debugLineNum = 166;BA.debugLine="Dim Y As Float = Args.Arg4";
_y = (float)(BA.ObjectToNumber(_args.Arg4));
 //BA.debugLineNum = 167;BA.debugLine="Dim MotionEvent As Object = Args.Arg5";
_motionevent = _args.Arg5;
 //BA.debugLineNum = 169;BA.debugLine="Select Case ViewTag";
switch (BA.switchObjectToInt(_viewtag,"et1","et2","et3")) {
case 0:
 //BA.debugLineNum = 171;BA.debugLine="Select Action";
switch (BA.switchObjectToInt(_action,mostCurrent._activity.ACTION_DOWN,mostCurrent._activity.ACTION_MOVE,mostCurrent._activity.ACTION_UP)) {
case 0:
 //BA.debugLineNum = 173;BA.debugLine="eventtest = eventtest & \"et1_TOD, \"";
_v0 = _v0+"et1_TOD, ";
 break;
case 1:
 break;
case 2:
 //BA.debugLineNum = 177;BA.debugLine="eventtest = eventtest & \"et1_TOU, \"";
_v0 = _v0+"et1_TOU, ";
 break;
}
;
 break;
case 1:
 //BA.debugLineNum = 180;BA.debugLine="Select Action";
switch (BA.switchObjectToInt(_action,mostCurrent._activity.ACTION_DOWN,mostCurrent._activity.ACTION_MOVE,mostCurrent._activity.ACTION_UP)) {
case 0:
 //BA.debugLineNum = 182;BA.debugLine="eventtest = eventtest & \"et2_TOD, \"";
_v0 = _v0+"et2_TOD, ";
 break;
case 1:
 break;
case 2:
 //BA.debugLineNum = 186;BA.debugLine="eventtest = eventtest & \"et2_TOU, \"";
_v0 = _v0+"et2_TOU, ";
 break;
}
;
 break;
case 2:
 //BA.debugLineNum = 189;BA.debugLine="Select Action";
switch (BA.switchObjectToInt(_action,mostCurrent._activity.ACTION_DOWN,mostCurrent._activity.ACTION_MOVE,mostCurrent._activity.ACTION_UP)) {
case 0:
 //BA.debugLineNum = 191;BA.debugLine="eventtest = eventtest & \"et3_TOD, \"";
_v0 = _v0+"et3_TOD, ";
 break;
case 1:
 break;
case 2:
 //BA.debugLineNum = 195;BA.debugLine="eventtest = eventtest & \"et3_TOU, \"";
_v0 = _v0+"et3_TOU, ";
 break;
}
;
 break;
}
;
 //BA.debugLineNum = 198;BA.debugLine="End Sub";
return "";
}
}
